// This Photoshop CS/CS2 script will copy the layer masks from
// document A to document B, assuming that 2 documents are open in 
// Photoshop when running this script.
// If only one document is open, then the layer masks from that doc
// will be copied to a new document.
//
// By Eric Gerds                  http://www.pinlady.net/vr
// LayerMaskCopy version 1.3.2    Feb 2006
//
// To Do:
// - Code is kind of sloppy
// - Way to speed up script
// - Have a preferences gui, that sets whether you want the layer visibilities
//     to be saved at startup of script, and then restored when script is done.


// Save the visibility of input doc, return array
function saveVisibility(doc){
var vis = [];
for (var i=0;i< doc.layers.length; i++){vis[i] = doc.layers[i].visible};
return vis;  // return array
};



// Duplicate activedocument and give it a name of docname
function duplicateimage(docname){
var id17 = charIDToTypeID( "Dplc" );
var desc5 = new ActionDescriptor();
var id18 = charIDToTypeID( "null" );
var ref2 = new ActionReference();
var id19 = charIDToTypeID( "Dcmn" );
var id20 = charIDToTypeID( "Ordn" );
var id21 = charIDToTypeID( "Frst" );
ref2.putEnumerated( id19, id20, id21 );
desc5.putReference( id18, ref2 );
var id22 = charIDToTypeID( "Nm  " );
desc5.putString( id22, docname );
executeAction( id17, desc5, DialogModes.NO );

};


// Load selection (into the active document) from Channel Mask of active layer 
// of document reference 'doc'.
// 'doc' is not necessarily the active document.
function loadselection(doc){

// If active layer of doc is the background layer, then there is no channel
// mask.
if (doc.activeLayer.isBackgroundLayer){
   app.activeDocument.selection.selectAll();
   return false;
   };

var id333 = charIDToTypeID( "setd" );
var desc68 = new ActionDescriptor();
var id334 = charIDToTypeID( "null" );
var ref57 = new ActionReference();
var id335 = charIDToTypeID( "Chnl" );
var id336 = charIDToTypeID( "fsel" );
ref57.putProperty( id335, id336 );
desc68.putReference( id334, ref57 );
var id337 = charIDToTypeID( "T   " );
var ref58 = new ActionReference();
var id338 = charIDToTypeID( "Chnl" );
var id339 = charIDToTypeID( "Chnl" );
var id340 = charIDToTypeID( "Msk " );
ref58.putEnumerated( id338, id339, id340 );
var id341 = charIDToTypeID( "Dcmn" );
ref58.putName( id341, doc.name );
desc68.putReference( id337, ref58 );

try{
  executeAction( id333, desc68, DialogModes.NO );
  return true;  // Channel mask exists
                // However, just because the mask exists, that does not mean
                // that you end up with a selection. If the entire mask is
                // black, then there will be no selection at all!
   }
catch(e){
  // If error, then this probably means that mask does not exist.
  // Thus, we select the entire area
  app.activeDocument.selection.selectAll();
  return false; // Channel mask does NOT exist
                }
};


// Save the selection in the active Document into a NEW doc,
// and put it into an Alpha Channel named alphaname.
// This Alpha channel in the new doc is NOT a layer mask.
// alphaname is the string name for the new alpha layer.
function SaveSelectAsAlphaNewDoc(alphaname){
var docA = app.activeDocument, docB;

var id39 = charIDToTypeID( "Mk  " );
var desc9 = new ActionDescriptor();
var id40 = charIDToTypeID( "Nw  " );
var id41 = charIDToTypeID( "Dcmn" );
desc9.putClass( id40, id41 );
var id42 = charIDToTypeID( "Usng" );
var ref8 = new ActionReference();
var id43 = charIDToTypeID( "Chnl" );
var id44 = charIDToTypeID( "fsel" );
ref8.putProperty( id43, id44 );
desc9.putReference( id42, ref8 );
var id45 = charIDToTypeID( "ChnN" );
desc9.putString( id45, alphaname );

try{
 executeAction( id39, desc9, DialogModes.NO );
}
catch(e){
     // if error, then there was probably no selection present,
     // so we wish to create a BLACK alpha channel in the new document

     docA.selection.selectAll();                    // We select ALL
     executeAction( id39, desc9, DialogModes.NO );  // Save to new document

     if (docA==app.documents[0]){docB = app.documents[1]}
     else{docB = app.documents[0]};

     app.activeDocument = docB;   // and then make that Alpha channel BLACK
     docB.selection.selectAll();
     var tt = new SolidColor(); tt.rgb.red = 0; tt.rgb.green = 0; tt.rgb.blue = 0;
     docB.selection.fill(tt);
     docB.selection.deselect();

     app.activeDocument = docA;
     docA.selection.deselect();

};

};

// Save the selection in the active Document into document 'doc',
// and put it into the topmost Alpha Channel named alphaname.
// The Alpha channel is created first.
// This Alpha channel is NOT a layer mask.
function SaveSelectAsAlpha(doc,alphaname){
docname = doc.name;

var id80 = charIDToTypeID( "Dplc" );
var desc17 = new ActionDescriptor();
var id81 = charIDToTypeID( "null" );
var ref18 = new ActionReference();
var id82 = charIDToTypeID( "Chnl" );
var id83 = charIDToTypeID( "fsel" );
ref18.putProperty( id82, id83 );
desc17.putReference( id81, ref18 );
var id84 = charIDToTypeID( "T   " );
var ref19 = new ActionReference();
var id85 = charIDToTypeID( "Dcmn" );
ref19.putName( id85, docname );
desc17.putReference( id84, ref19 );
var id86 = charIDToTypeID( "Nm  " );
desc17.putString( id86, alphaname );

try{
  executeAction( id80, desc17, DialogModes.NO );   // **** Error?
}
catch(e){
  // If error, then probably no selection exists.
  // Then we create a BLACK Alpha Channel in doc
  app.activeDocument = doc;
  var  aa = doc.channels.add();
  aa.kind = ChannelType.MASKEDAREA;
  aa.name = alphaname;
  doc.selection.selectAll();
  var tt = new SolidColor();
  tt.rgb.red = 0; tt.rgb.green = 0; tt.rgb.blue = 0;
  doc.selection.fill(tt);
  doc.selection.deselect();
};

}

// Save Selection into Layer Mask for the active layer of the active doc.
// The exception here is for the background layer. The background layer
// cannot have a layer mask.
function saveselection(){
if (app.activeDocument.activeLayer.isBackgroundLayer){return};

var id342 = charIDToTypeID( "setd" );
var desc69 = new ActionDescriptor();
var id343 = charIDToTypeID( "null" );
var ref59 = new ActionReference();
var id344 = charIDToTypeID( "Chnl" );
var id345 = charIDToTypeID( "Chnl" );
var id346 = charIDToTypeID( "Msk " );
ref59.putEnumerated( id344, id345, id346 );
desc69.putReference( id343, ref59 );
var id347 = charIDToTypeID( "T   " );
var ref60 = new ActionReference();
var id348 = charIDToTypeID( "Chnl" );
var id349 = charIDToTypeID( "fsel" );
ref60.putProperty( id348, id349 );
desc69.putReference( id347, ref60 );

try{executeAction( id342, desc69, DialogModes.NO );
    return true
}


catch(e){
    // if error, then we were unable to save the selection to channel mask.
    // The reason for this is because no selection exists.
    // Hence, we create a 'Hide ALL' mask.

    var id410 = charIDToTypeID( "Mk  " );
    var desc91 = new ActionDescriptor();
    var id411 = charIDToTypeID( "Nw  " );
    var id412 = charIDToTypeID( "Chnl" );
    desc91.putClass( id411, id412 );
    var id413 = charIDToTypeID( "At  " );
    var ref86 = new ActionReference();
    var id414 = charIDToTypeID( "Chnl" );
    var id415 = charIDToTypeID( "Chnl" );
    var id416 = charIDToTypeID( "Msk " );
    ref86.putEnumerated( id414, id415, id416 );
    desc91.putReference( id413, ref86 );
    var id417 = charIDToTypeID( "Usng" );
    var id418 = charIDToTypeID( "UsrM" );
    var id419 = charIDToTypeID( "HdAl" );
    desc91.putEnumerated( id417, id418, id419 );
    
    try{executeAction( id410, desc91, DialogModes.NO )}
    catch(e){}

};

};


// --------------------------------------------------------------

// Verify the presence of component channels (R, G, or B).
// Return the number of component channels found.
function componentchannels(doc){
var comp=0;
for (var i=0; i<doc.channels.length; i++){
    // if (doc.channels[i].kind == ChannelType.MASKEDAREA){}
    if (doc.channels[i].kind == ChannelType.COMPONENT){comp++}
        }
return(comp);

};

// Make sure there is a one to one correspondence of layer types
// in the 2 docs.
// Return false if there is no correspondence, return true if there is.
// We want to make sure that a NORMAL layer in docA corresponds to
// a NORMAL layer in docB.
//
// Examples - if layer 1 (docA) = NORMAL, but layer 1 (docB) = layer set,
// then error.
// if layer 1 (docA) = NORMAL, but layer 1 (docB) = Curves Adjust Layer,
// then error.
// if layer 1 (docA) = Any Adjust Layer type, and layer 1 (docB) = Any
// Adjust Layer type, then ok.
//
// Found a small bug in Photoshop here (I think).
// In order to correctly detect the kind of layer (when an adjustment layer),
// you should have that doc as the ACTIVE doc. Otherwise, PS may think that
// an adjustment layer is a NORMAL layer.
//
// Note that the .kind property for a layerset is 'undefined'
//
// Is it possible to determine whether a doc has no masks on any layer?
// If so, then by default we would just copy masks TO that doc.
function checklayertypes(docA,docB){
var tmpA = docA.layers.length;
var tmpB = docB.layers.length;
var i;
var LayerTypesA=new Array(),LayerTypesB = new Array();

app.activeDocument = docA;
for (i=0; i< Math.min(tmpA,tmpB); i++){
  LayerTypesA[i] = docA.layers[tmpA-1-i].kind;

};

app.activeDocument = docB;
for (i=0; i< Math.min(tmpA,tmpB); i++){
  LayerTypesB[i] = docB.layers[tmpB-1-i].kind;

};

for (i=0; i< Math.min(tmpA,tmpB); i++){
  if (LayerTypesA[i] == LayerKind.NORMAL &&
      LayerTypesB[i] != LayerKind.NORMAL) {return false};
  if (LayerTypesA[i] != LayerKind.NORMAL &&
      LayerTypesB[i] == LayerKind.NORMAL) {return false};
    }
    
// If one doc has a background layer, and the other doesn't
// then return false.
if (docA.layers[tmpA-1].isBackgroundLayer !=
    docB.layers[tmpB-1].isBackgroundLayer){return false};

return true;

};


// Copy Alpha Channels from docB to the channel masks of docA.
// docB has no component channels, ONLY alpha channels.
function main2(){
if (app.documents.length!=2){return};

var docA=app.documents[0], docB=app.documents[1], i;

// Count the number of component channels in each document
var compA=componentchannels(docA), compB=componentchannels(docB);


var tmp;
if (compA==0 && compB>0){
   tmp = docA;
   docA = docB;
   docB = tmp;
  };

var numBchannels = docB.channels.length;
var numAlayers = docA.layers.length;

if (numBchannels!=numAlayers){
  if (confirm(
    "Warning: The number of masks in the source document does\n" +
    "not match the number of layers in the target document.\n" +
    "Copying will start with the bottommost masks/layers.\n" +
    "Proceed?")==false){return}
};


app.activeDocument = docA;

// Save visibility of layers for docA
// var docAvisible = saveVisibility(docA); // Array of visibility


// We need this statement to prevent output message 
// when selection.load() does not load any selection at all.
app.displayDialogs = DialogModes.NO;

// Start the copying from the lowest Alpha channel of docB to lowest layer
// of docA and then work your way up.
for (i=0;i<Math.min(numAlayers,numBchannels);i++){
    app.activeDocument = docA;
    docA.activeLayer = docA.layers[numAlayers -1 -i];
    
   // Restore docA layer visibility
   // if (docA.layers[numAlayers -1 -i].visible != docAvisible[numAlayers -1 -i]){
   //     docA.layers[numAlayers -1 -i].visible = docAvisible[numAlayers -1 -i]};

    try{
    docA.selection.load(docB.channels[numBchannels -1 -i],SelectionType.REPLACE,false);
    }
    catch(e){};

    saveselection(); // Save selection into layer mask of docA

};

app.activeDocument = docA;
docA.selection.deselect();

alert("Done!");
}



// Copy layer masks from an open document into a new document
// as Alpha Channels.
function main1(){
if (app.documents.length!=1){return};

var docA = app.activeDocument,docB=null;
var i,tmp,alphadoc="layermasks-" + docA.name;


// Save visibility of layers for each doc
// var docAvisible = saveVisibility(docA); // Array of visibility

if (componentchannels(docA)==0){return}; // No component channels, then exit


// What if a layer has no layer mask?
for (i=0;i<docA.layers.length;i++){
  app.activeDocument = docA;
  docA.activeLayer = docA.layers[i];

  // Restore docA layer visibility
  //if  (docA.layers[i].visible != docAvisible[i]){
  //        docA.layers[i].visible = docAvisible[i]};

  loadselection(docA); // Load selection from mask of active layer

  if (i==0){
     SaveSelectAsAlphaNewDoc(docA.layers[i].name + " mask");
     if (docA==app.documents[0]){docB = app.documents[1]}
     else{docB = app.documents[0]};
     
     // To get the newly created doc to have the name we want,
     // we duplicate it and give the duplicate that name.
     app.activeDocument = docB;
     
     if (docA.name!= alphadoc){duplicateimage(alphadoc)}
     else{duplicateimage(alphadoc+"_")};

     docB.close(SaveOptions.DONOTSAVECHANGES);
     if (docA==app.documents[0]){docB = app.documents[1]}
     else{docB = app.documents[0]};

          }
  else{
      SaveSelectAsAlpha(docB,docA.layers[i].name + " mask");
       }

};


app.activeDocument = docA;
docA.selection.deselect();


// docB has no component channels, only alpha channels

alert("Done!");
};


// If activelayer has a mask, then return true, else false
function findmask(){
var desc108 = new ActionDescriptor();
var ref92 = new ActionReference();
ref92.putEnumerated( charIDToTypeID( "Chnl" ), charIDToTypeID( "Chnl" ),
    charIDToTypeID( "Msk " ) );
desc108.putReference( charIDToTypeID( "null" ), ref92 );
desc108.putBoolean( charIDToTypeID( "MkVs" ), false );

// We try to select the channel mask. If we are able to, then the mask exists
try{executeAction( charIDToTypeID( "slct" ), desc108, DialogModes.NO ); return true}
catch(e){return false};  // else, mask does not exist
return false;

};

// Determine if a doc has one or more layer masks.
// If it has one or more masks, then return true.
// If it has zero masks, then return false.
function countmasks(){
var doc = app.activeDocument;

// Dummy selection to prevent histo building to speed up script?
try{doc.selection.select([[0,0],[2,0],[2,2],[0,2],[0,0]],SelectionType.REPLACE)}
catch(e){};

for (var i=0; i<doc.layers.length;i++){
   doc.activeLayer = doc.layers[i]; 
   if (findmask()){return true}
};
return false;

};



// Copy layer masks from document B to document A.
function main0(){
if (app.documents.length!=2){
   alert("Error! 2 documents must be open.");
   return
}; // 2 documents must be open

// Assign each doc to variable
var docA;
var docB = G.SOURCE; // G.SOURCE was active doc when script started
if (docB==app.documents[0]){docA = app.documents[1]}
else{docA = app.documents[0]};

// Masks will be copied from docB to docA


// Save visibility of layers for each doc
// var docAvisible = saveVisibility(docA); // Array of visibility
// var docBvisible = saveVisibility(docB); // Array of visibility

var countMaskA, countMaskB, swap;

// See if docA has zero layer masks
app.activeDocument = docA;
countMaskA = countmasks(); // true/false


// See if docB has zero layer masks
app.activeDocument = docB;
countMaskB=countmasks();  // true/false


// Decide which document is the SOURCE doc for masks and which is the TARGET
// doc for the masks.
if (!countMaskA && !countMaskB){return}; // Neither doc has masks, so return
if (countMaskA && !countMaskB){swap = docA; docA = docB; docB = swap};
if (!countMaskA && countMaskB){};
if (countMaskA && countMaskB){    // Both docs have masks, so ask which doc
   app.activeDocument = docB;     // should be the source

   // docB is active document right now, which is G.SOURCE
   if (!confirm("Copy layer masks FROM \"" + docB.name + "\" \n"+
                "TO other document?")){
      if(confirm("Copy layer masks TO \"" + docB.name + "\" \n"+
                "FROM other document?")){
          swap = docA; docA = docB; docB = swap}
      else{return};
     };

};


var tmpA = docA.layers.length;
var tmpB = docB.layers.length;

if (tmpA!=tmpB){
  if (confirm(
    "Warning: The 2 documents do not have the same number of layers.\n" +
    "The masks are copied starting at the bottommost layer in both \n" +
    "documents. Proceed?")==false){return}
};



var i;
for (i=0; i<Math.min(tmpA,tmpB); i++){

  app.activeDocument = docB;
  if (i==0){   // Make small dummy selection to prevent histogram building
        try{docB.selection.select([[0,0],[2,0],[2,2],[0,2],[0,0]],SelectionType.REPLACE)}
        catch(e){}
        };
  docB.activeLayer = docB.layers[tmpB-1-i]; // set the active layer for doc B
  
  // Restore docB layer visibility
  //  docB.layers[tmpB-1-i].visible = docBvisible[tmpB-1-i];

  // In last loop iteration, deselect docB
  if (i == Math.min(tmpA,tmpB) - 1){docB.selection.deselect()};

  // Set the active layer for docA
  app.activeDocument = docA;
  docA.activeLayer = docA.layers[tmpA-1-i];
  
  // Restore docA layer visibility
  //  docA.layers[tmpA-1-i].visible = docAvisible[tmpA-1-i];

  loadselection(docB); // Load selection from channel mask of docB.
  saveselection();     // Save selection to channel mask of docA.

  try{docA.selection.select([[0,0],[2,0],[2,2],[0,2],[0,0]],SelectionType.REPLACE)}
        catch(e){}

};

// Deselect docA
docA.selection.deselect();


alert("Done!");
};




// Decide which function to call - main0(), main1(), or main2().
//
// main0() copies layer masks from one layered doc to the layer masks of
// another layered doc. Both documents have to be open simultaneously.
// main1() copies the layer masks from a layered doc to a NEW doc which
// will only contain alpha channels (and hence uses very little memory).
// main2() copies the alpha channels from the NEW doc to the layer masks
// of a multi-layered doc.
function main(){
if (app.documents.length>2){
     alert("Error: Too many open documents.")
     return};

if (app.documents.length==0){
     alert("Error: No documents are open");
           return};

var selregion = [[0,0],[2,0],[2,2],[0,2],[0,0]];
// Put small selection box in each image to prevent histogram building

// If we have 2 multilayered documents open, then the active doc when the
// script starts up should be the SOURCE of the masks, 
// and the other doc the TARGET - assuming that both docs have masks.
G.SOURCE = app.activeDocument;

var warn = false;
for (var i=0; i<app.documents.length; i++){
  app.activeDocument = app.documents[i];
  app.activeDocument.selection.select(selregion,SelectionType.REPLACE);
  if (app.documents[i].layerSets.length>0){warn = true};
}

// PS CS uses the term 'layerset' but PS CS2 uses the term 'group'
if (warn){alert("Warning: Any layers inside a layerset\n" +
                "or layergroup will not be processed.")};

// If only one doc open, then copy its layer masks to alpha channels
// in a NEW doc.
if (app.documents.length==1){main1();return};


// If we reach this point, then exactly 2 documents are open.

// Make sure both docs are the same size.
if ((app.documents[0].width.value != app.documents[1].width.value) ||
 (app.documents[0].height.value != app.documents[1].height.value)){
  alert("Error! The 2 open documents need to be the same\n" +
        "size (Width x Height) when running this script.");
  return;
 }


// So we need to call main0 or main2.
// Count the number of component channels in each document
var compA=componentchannels(app.documents[0]),
    compB=componentchannels(app.documents[1]);
if (compA>0 && compB>0){
   // Make sure the layer types correspond between the 2 documents.
   // One doc may have a background layer, the other does not.
   // Or, one may be an adjustment layer, the other an art layer.
   if (!checklayertypes(app.documents[0],app.documents[1])){
     if (!confirm("Warning: Layer types do not match between the 2\n" +
         "documents (ie. Layer i of document A is not the same type\n" +
         "as Layer i of document B). Proceed?") ){return};

       };
   main0();
   return};

if ((compA>0 && compB==0)|| (compA==0 && compB>0)){main2();return};

return; // Neither doc has component channels
}

// ---------------------------------------------------
var G = new Object();     // Global object
main();

